local addonName, addonTable = ...
local L = addonTable.L

--------------------------------------
-- dialog (fyhcslb 8/30/2016)
--------------------------------------
local dialog = CreateFrame("Frame", addonName .. "Dialog", UIParent)
local confirmBtn = CreateFrame("Button", addonName .. "ConfirmButton", dialog, "UIPanelButtonTemplate")
local closeBtn = CreateFrame("Button", addonName .. "CloseButton", dialog, "UIPanelButtonTemplate")
local editBox = CreateFrame("EditBox", addonName .. "EditBox", dialog)
local scroll = CreateFrame("ScrollFrame", addonName .. "Scroll", dialog, "UIPanelScrollFrameTemplate")
local dialogDesc = dialog:CreateFontString(addonName .. "DialogDesc", "OVERLAY", "GameFontNormalLarge")

dialog:Hide()
dialog:SetFrameStrata("FULLSCREEN_DIALOG")
dialog:SetClampedToScreen(true)
dialog:SetSize(500, 400)

dialog:SetBackdrop({
      bgFile = [[Interface\Buttons\WHITE8x8]], 
      edgeFile = [[Interface\Tooltips\UI-Tooltip-Border]], 
      tile = true, tileSize = 16, edgeSize = 16,
      insets = { left = 4, right = 4, top = 4, bottom = 4 }
})
dialog:SetBackdropColor(0, 0, 0, 0.85)

dialog:SetPoint("CENTER")
dialog:EnableMouse(true)
dialog:SetMovable(true)
dialog:SetUserPlaced(false)

confirmBtn:SetSize(60, 21)
confirmBtn:SetPoint("TOPRIGHT", -65, -3)
confirmBtn:SetText(L.SAVE)
confirmBtn.tooltipText = L.SAVE_DESC

closeBtn:SetSize(60, 21)
closeBtn:SetPoint("TOPRIGHT", -3, -3)
closeBtn:SetText(L.CLOSE)

-- editBox:SetPoint("TOPLEFT", 20, -40)
-- editBox:SetPoint("TOPRIGHT", -20, -40)
-- editBox:SetPoint("BOTTOMLEFT", 20, 20)

editBox:SetFontObject("ChatFontNormal")
editBox:SetMultiLine(true)
editBox:SetMaxLetters(0)
editBox:SetWidth(460)
editBox:SetHeight(340)

scroll:SetPoint('TOPLEFT', dialog, 'TOPLEFT', 8, -30)
scroll:SetPoint('BOTTOMRIGHT', dialog, 'BOTTOMRIGHT', -30, 8)
scroll:SetScrollChild(editBox)

dialogDesc:SetPoint("TOPLEFT", 10, -5)
-- dialogDesc:SetSize(200, 20)
dialogDesc:SetText(L.DIALOG_DESC)

-- script
confirmBtn:SetScript("OnClick", function(self, button, down) addonTable.save(editBox:GetText()) end)
closeBtn:SetScript("OnClick", function(self, button, down) self:GetParent():Hide() end)
dialog:SetScript("OnMouseDown", function(self, button) self:StartMoving() end)
dialog:SetScript("OnMouseUp", function(self, button) self:StopMovingOrSizing() end)
editBox:SetScript('OnEscapePressed', function() dialog:Hide() end)

-- func
local function ShowDialog(text)
	editBox:SetText(text)
	-- editBox:HighlightText()
	dialog:Show()
end

addonTable.ShowDialog = ShowDialog